%Vagelis Papalexakis, 2014
%School of Computer Science, Carnegie Mellon University
%Demo of the GeBM - Good Enough Brian Model, and the Sparse System
%Identification algorithm. The current version is using the Matlab System
%Identification Toolbox.

clear all; close all; clc
%First, we create the original Ao, Bo, Co matrices of the GeBM model.
n = 5;%number of hidden states
Ao = 0.4*eye(n);
for i = 1:n-1
   Ao(i,i+1) = 0.1;
end
for i = 2:n
   Ao(i,i-1) = -0.15; 
end
m = 10;%number of observed voxels
s  = 30;%number of input voxels
Co = sprandn(m,n,1);
Bo = sprandn(n,s,1);

%Second, we create input/output training pairs, by probing the GeBM model
%with random inputs
time = n*200;
u = randn(s,time);%input
x = zeros(n,time);%hidden output
xlast = zeros(n,1);
%simulate the system
for i = 1:time
    x(:,i) = Ao*xlast + Bo*u(:,i);
    xlast = x(:,i);
end
y = Co*x;%observed output

%Third, using the input/output pairs, we estimate the GeBM model:

% [A, B, C, Av] = sparse_sysid(u,y,n);%using LTI Toolbox %%Currently not
% available online, need to contact the LTI Toolbox team for permission to
% download their code, first!
[A, B, C, Av] = sparse_sysid_alt(u,y,n);%using Matlab System Identification Toolbox

%Qualitative comparison of the two voxel-to-voxel connectivities
figure
subplot(1,2,1);imagesc(Co*Ao*pinv(full(Co)));colorbar
subplot(1,2,2);imagesc(Av);colorbar
suptitle('Left: Original Av | Right: Estimated Av')

