function [A, B, C, Av] = sparse_sysid_alt(u,y,n)
%Vagelis Papalexakis, 2014
%School of Computer Science, Carnegie Mellon University
%Sparse System Identification Algorithm. Uses the N4SID subspace system
%identification algorithm at its core.
data = iddata(y',u',1);
opt = n4sidOptions('EstCovar',false,'InitialState','zero','N4Weight','CVA','Focus','simulation','OutputWeight','noise');
sys = n4sid(data,n,opt);
A = sys.A; C = sys.C; B = sys.B;
A = eig_aware_sparsification(A);
B = sparsify_matrix(B);
C = sparsify_matrix(C);
Av = C*A*pinv(full(C));