function [Anew] = sparsify_matrix(A)
%Vagelis Papalexakis, 2014
%School of Computer Science, Carnegie Mellon University
%Part of the Sparse System Identification Algorithm. 
%Given a rectangular (tall or fat) matrix A, we calculate a sparse version of it
%while keeping its singluar values within \epsilon (elementwise)

tol = 10^-3;
Anew = A;
lambda_old = svd(A);
isComplex = imag(lambda_old)~=0;

for i = 1:nnz(A)
    Atmp = Anew; Atmp(Atmp==0) = Inf;
    [idxi, idxj] = find(min(min(abs(Atmp)))==abs(Atmp));
    
    Aold = Anew;
    Anew(idxi,idxj) = 0;
    
    lambda_new=svd(Anew);
    
    delta = abs((lambda_new) - real(lambda_old) );
    lambda_old = lambda_new;
        if sum((delta)>tol)>0 
       Anew = Aold;
       break
    end
end

disp(sprintf('Successfully deleted %d non-zero connections',i-1))
